myXML = new XML();
radio_XML = new XML();
function getText(node) {
	text = "";
	for (var i = 0; i<node.childNodes.length; i++) {
		if (node.childNodes[i].nodeType == 3) {
			text += node.childNodes[i].nodeValue;
		}
	}
	return text;
}
myXML.trace = function() {
	// this.indent  = "   |" +this.indent;
	if (this.nodeType == 1) {
		// element
	}
	trace(this.indent+" [Element]  "+this.nodeName);
	if (this.nodeType == 3 && !this.isBlank()) {
		// text
	}
	trace(this.indent+" text)   "+this.nodeValue);
	for (name in this.attributes) {
		trace(this.indent+"   +-attr-->"+name+":  "+this.attributes[name]);
	}
	for (var i = 0; i<this.childNodes.length; i++) {
		this.childNodes[i].isBlank = this.isBlank;
		this.childNodes[i].trace = this.trace;
		this.childNodes[i].indent = "   |"+this.indent;
		this.childNodes[i].trace();
	}
};
myXML.isBlank = function() {
	for (var i = 0; i<this.nodeValue.length; i++) {
		if (this.nodeValue.charCodeAt(i)>32) {
			return false;
		}
	}
	return true;
};
myXML.onLoad = function(ok) {
	if (!ok) {
		trace("load failure");
	} else {
		trace(this.toString());
		this.trace();
	}
};
radio_XML.trace = function() {
	// Recurse through the tree
	for (var i = 0; i<this.childNodes.length; i++) {
		this.childNodes[i].trace = this.trace;
		this.childNodes[i].trace();
	}
	// Now check for particular nodes and build data structure
	// First build songs array
	if (this.nodeName == "song") {
		trace("**found song");
		for (var i = 0; i<this.childNodes.length; i++) {
			if (this.childNodes[i].nodeType == 1) {
				switch (this.childNodes[i].nodeName) {
				case "title" :
					strTitle = getText(this.childNodes[i]);
					break;
				case "composer" :
					strComposer = getText(this.childNodes[i]);
					break;
				case "file" :
					strFile = getText(this.childNodes[i]);
					break;
				default :
					break;
				}
				// end switch
			}
			// end if
		}
		// end for
		// Now create song
		if (!_root.newSongArray) {
			_root.newSongArray = new Array();
		}
		_root.newSongArray.push(new _root.Song(strTitle, strComposer, strFile));
		trace("**strTitle: "+strTitle+" * strComposer: "+strComposer+" * strFile: "+strFile);
		trace("newSongArray.length: "+_root.newSongArray.length);
		trace("_root.traceSong["+(_root.newSongArray.length-1)+"]: ");
		_root.traceSong(_root.newSongArray[_root.newSongArray.length-1]);
		trace("manual access strTitle: "+_root.newSongArray[_root.newSongArray.length-1].title);
		trace("");
	}
	// Now Build Station Array
	if (this.nodeName == "station") {
		for (name in this.attributes) {
			if (name == "name") {
				strName = this.attributes[name];
				if (!_root.newStationArray) {
					_root.newStationArray = new Array();
				}
				_root.newStationArray.push(new _root.Station(strName, _root.newSongArray));
			}
		}
		trace("");
		trace("station[name]: "+strName);
		trace("call _root.traceStation()");
		_root.traceStation(_root.newStationArray[_root.newStationArray.length-1]);
		trace("");
		delete (_root.newSongArray);
	}
	if (this.nodeName == "radio") {
		_root.objRadio = new _root.Radio(_root.newStationArray);
	}
};
function traceElements(node) {
	for (var i = 0; i<node.childNodes.length; i++) {
		if (node.childNodes[i].nodeType == 1) {
			trace("[el: "+node.childNodes[i].nodeName);
			var strVal = getText(node.childNodes[i]);
			trace("    val: "+strVal);
		}
	}
}
radio_XML.cleanse = function() {
	if (this.nodeType == 3) {
		for (var i = 0; i<this.nodeValue.length; i++) {
			if (this.nodeValue.charCodeAt(i)>32) {
				return;
			}
		}
		this.removeNode();
	} else {
		for (var i = this.childNodes.length; i--; ) {
			this.childNodes[i].cleanse = this.cleanse;
			this.childNodes[i].cleanse();
		}
	}
};
radio_XML.isBlank = function() {
	for (var i = 0; i<this.nodeValue.length; i++) {
		if (this.nodeValue.charCodeAt(i)>32) {
			return false;
		}
	}
	return true;
};
radio_XML.onLoad = function(ok) {
	if (!ok) {
		trace("load failure");
	} else {
		trace(this.toString());
		this.cleanse();
		this.trace();
		trace("inline call of _root.traceRadio();");
		_root.traceRadio(_root.objRadio);
		_root.nextFrame();
	}
};
myXML.load(url);
radio_XML.load(url);
